//<c>   Copyright 1995-2000 by Gerry J. Danen; all rights reserved.

//<t>   Convert an ASCII file to a colored ANSI file

//      Make sure line length of input file is max. 65 chars!
//
//              Usage:  ANSCOLOR file_in file_out
//
//      Full pathnames are supported for the filenames.
//
#include"gd_tools.h"


#define pgVERS_ "V2.00"
#define pgTITL_ "Convert ASCII to ANSI colored text file"
#define pgCOPR_ "1995"


// #define ANS_RESET       "\x1B[0;37;40m\x1B[K"
#define ANS_RESET       "\x1B[0;37;40m"
#define ANS_WHITE       "\x1B[0;30;47m"
#define ANS_GREEN       "\x1B[0;30;42m"


UCHAR   iFile[FS_LEN], oFile[FS_LEN], work[10001], *w ;
long    lines = 0 ;
FILE    *iFh, *oFh ;
STRING  sSeparatorTop = "Ŀ" ;
STRING  sSeparatorBot = "" ;


void    ShowHelp( void )
{
    logon(1);
    fprintf( stderr, "\n\nUsage:\t%s file_in file_out\n\n"
                     "\tMaximum line length is 65 chars.\n\n",
                     get_global_program_name() );
    exit( 1 );
}


void    write_record( STRING s, BOOL colorize )
{
    static UCHAR bfr[100], b1[10], b2[100], b3[10] ;
    static int three = 3 ;
    static BOOL bColour = FALSE ;
    static STRING pBanner = ANS_GREEN ;

    if ( strlen(s) > 65 && colorize )
    {
        fprintf( oFh, ">>> TOO LONG: %s", s );
        return ;
    }
    if ( strlen(s) > 65 )                       // first or last line
    {
        strcpy( bfr, s );
    }
    else
    {
        if ( Is_Odd((int) lines) )
            sprintf( bfr, "| o |  %-65s  | o |", s );
        else
            sprintf( bfr, "|   |  %-65s  |   |", s );
    }

    st_cpy( b1, &bfr[ 0], 7 );
    st_cpy( b2, &bfr[ 6], 68);
    st_cpy( b3, &bfr[73], 9 );

    if ( colorize )
    {
        three += 1 ;
        if ( three > 3 )
        {
            three = 1 ;
            if ( bColour )
                bColour = FALSE ;
            else
                bColour = TRUE ;
        }
        if ( bColour )
            pBanner = ANS_GREEN ;
        else
            pBanner = ANS_WHITE ;
    }
    else
        pBanner = ANS_WHITE ;

    fprintf( oFh, "%s%s%s%s%s%s%s\n", ANS_WHITE, b1, pBanner, b2, ANS_WHITE, b3, ANS_RESET );
    lines += 1 ;
}


void    main( int argc, char *argv[] )
{
    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    if ( argc != 3 )
        ShowHelp();

    st_cpy( iFile, (UCHAR *) argv[1], FS_LEN );
    st_cpy( oFile, (UCHAR *) argv[2], FS_LEN );
    strupr( (char *) iFile );
    strupr( (char *) oFile );

    if ( ( iFh = fopen( iFile, "r" ) ) == NULL )
    {
        logon(1);
        fprintf( stderr, "\n\nFile %s not found\a\n", iFile );
        ShowHelp();
    }

    oFh = fl_create_or_replace_tty( oFh, oFile, "w", YES, YES );

    fprintf( stderr, "%s: reading %s ...", get_global_program_name(), iFile );

    write_record( sSeparatorTop, FALSE );
    write_record( "", TRUE );

    for (;;)
    {
        w = fgets( work, (sizeof(work)-1), iFh );
        if ( w )
        {
            st_rtrim( work );
            write_record( work, TRUE );
        }
        if ( feof(iFh) )
        {
            write_record( "", TRUE );
            write_record( sSeparatorBot, FALSE );
            _fcloseall();
            fprintf( stderr, " %ld lines\n", lines );
            exit( 0 );
        }
    }
}
